﻿using System;
using System.Reflection;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ComponentControls
{
    /// <summary>
    /// Summary description for MyGridView
    /// </summary>
    public class LinqGridView : GridView
    {


        public int lbltotal
        {
            get
            {
                if (null != ViewState["lbltotal" + ControlID])
                    return (int)ViewState["lbltotal" + ControlID];
                else
                    return 0;
            }
            set
            {
                ViewState["lbltotal" + ControlID] = value;
            }
        }

        public int lblpageIndex
        {
            get
            {
                if (null != ViewState["lblpageIndex" + ControlID])
                    return (int)ViewState["lblpageIndex" + ControlID];
                else
                    return 0;
            }
            set
            {
                ViewState["lblpageIndex" + ControlID] = value;
            }
        }

        public string lblSortDirection
        {
            get
            {
                if (null != ViewState["lblSortDirection" + ControlID])
                    return (string)ViewState["lblSortDirection" + ControlID];
                else
                    return string.Empty;
            }
            set
            {
                ViewState["lblSortDirection" + ControlID] = value;
            }
        }

        public string lblSortExp
        {
            get
            {
                if (null != ViewState["lblSortExp" + ControlID])
                    return (string)ViewState["lblSortExp" + ControlID];
                else
                    return string.Empty;
            }
            set
            {
                ViewState["lblSortExp" + ControlID] = value;
            }
        }


        private string _controlId;

        public string ControlID
        {
            get { return _controlId; }
            set { _controlId = value; }
        }

       

        private string _DefaultSortExp;



        public string WhereClause
        {
            get
            {
                if (null != ViewState["whereClause" + ControlID])
                    return (string)ViewState["whereClause" + ControlID];
                else
                    return string.Empty;
            }
            set
            {
                ViewState["whereClause" + ControlID] = value;
            }
        }


        public string DefaultSortExp
        {
            set
            {
                _DefaultSortExp = value;
            }
            get
            {
                return _DefaultSortExp;
            }
        }

        public bool IsIndexChange
        {
            get
            {
                if (null != ViewState["isIndexChange" + ControlID])
                    return (bool)ViewState["isIndexChange" + ControlID];
                else
                    return false;
            }
            set
            {
                ViewState["isIndexChange" + ControlID] = value;
            }
        }

        public Type typeHolder
        {
            get
            {
                if (null != ViewState["typeHolder" + ControlID])
                    return (Type)ViewState["typeHolder" + ControlID];
                else
                    return null;
            }
            set
            {
                ViewState["typeHolder" + ControlID] = value;
            }
        }



        public event GridViewUpdateEventHandler onRowUpdateEvent
        {
            add
            {
                base.RowUpdating += value;
            }
            remove
            {
                base.RowUpdating -= value;
            }
        }




        public LinqGridView()
        {
            //
            // TODO: Add constructor logic here
            //

        }

        //protected Type typeHolder = null;
        public void BindGrid<T>() where T : class
        {
            try
            {
                if (null == typeHolder)
                    typeHolder = typeof(T);
                if (string.IsNullOrEmpty(lblSortExp))
                    lblSortExp = DefaultSortExp;
                    lblpageIndex = this.PageIndex;

                    lbltotal = EntityList<T>.GetCount(WhereClause);
                    string orderby = "" + lblSortExp + " " + (lblSortDirection == string.Empty ? " asc" : lblSortDirection);
                   
                    this.DataSource = EntityList<T>.GetEntityByPage(PageIndex, PageSize, WhereClause, orderby);
                    this.DataBind();
            }
            catch (Exception ex) { }
        }

        protected override void OnRowCommand(GridViewCommandEventArgs e)
        {
            base.OnRowCommand(e);
        }

        protected override void OnDataBound(EventArgs e)
        {
            base.OnDataBound(e);
        }


        protected override void InitializePager(GridViewRow row, int columnSpan, PagedDataSource pagedDataSource)
        {
            try
            {
                #region code for standard paging

                pagedDataSource.AllowCustomPaging = true;
                pagedDataSource.VirtualCount = Convert.ToInt32(lbltotal);
                pagedDataSource.CurrentPageIndex = lblpageIndex;

                #endregion code for standard paging

                base.InitializePager(row, columnSpan, pagedDataSource);
            }
            catch (Exception ex) { }
        }

        protected override void OnRowCreated(GridViewRowEventArgs e)
        {
            try
            {
                if (e.Row.RowType == DataControlRowType.DataRow)
                {
                    e.Row.ID = this.ID + "_" + e.Row.RowIndex;
                    e.Row.Attributes.Add("onmouseover", "this.style.cursor='pointer';this.style.font.weight='bolder';");
                    //e.Row.Attributes.Add("OnClick", "Anthem_FireCallBackEvent(this,event,'ctl00$ContentPlaceHolder1$" + ((GridView)this).ID + "$" + e.Row.ID + "$lbtn1','Update$',false,'','','',true,null,null,null,true,true);return false;");
                }
                else if (e.Row.RowType == DataControlRowType.Header)
                {
                    int index = GetSortColumnIndex();
                    if (index != -1)
                        sortingIcon(index, e.Row);
                }
                if (e.Row.RowType == DataControlRowType.Pager)
                {
                    DropDownList ddl = new DropDownList();
                    ddl.Items.Add("5");
                    ddl.Items.Add("10");
                    ddl.AutoPostBack = true;

                    ListItem li = ddl.Items.FindByText(this.PageSize.ToString());
                    if (li != null)
                        ddl.SelectedIndex = ddl.Items.IndexOf(li);
                    ddl.SelectedIndexChanged -= new EventHandler(ddl_SelectedIndexChanged);
                    ddl.SelectedIndexChanged += new EventHandler(ddl_SelectedIndexChanged);
                    Table pagerTable = e.Row.Cells[0].Controls[0] as Table;
                    TableCell cell = new TableCell();
                    cell.Style["padding-left"] = "50px";
                    cell.Style["text-align"] = "right";
                    cell.Controls.Add(new LiteralControl("Page Size:"));
                    cell.Controls.Add(ddl);
                    pagerTable.Rows[0].Cells.Add(cell);
                }
            }
            catch (Exception ex)
            {
                //hdl.logMessage(ex);
            }

            base.OnRowCreated(e);
        }


        void ddl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.PageSize > int.Parse(((DropDownList)sender).SelectedValue))
                IsIndexChange = true;
            else
                IsIndexChange = false;

            this.PageIndex = 0;
            //changes page size
            this.PageSize = int.Parse(((DropDownList)sender).SelectedValue);
            //binds data source
            MethodInfo method = this.GetType().GetMethod("BindGrid");
            MethodInfo generic = method.MakeGenericMethod(typeHolder);
            generic.Invoke(this, null);
        }

        protected override void OnRowUpdated(GridViewUpdatedEventArgs e)
        {
            base.OnRowUpdated(e);
        }

        protected override void OnSorting(GridViewSortEventArgs e)
        {
            try
            {
                lblSortExp = e.SortExpression;

                switch (lblSortDirection)
                {
                    case "asc":
                        {
                            lblSortDirection = "desc";
                            break;
                        }
                    case "desc":
                    case "":
                    case null:
                        {
                            lblSortDirection = "asc";
                            break;
                        }
                }
                MethodInfo method = this.GetType().GetMethod("BindGrid");
                MethodInfo generic = method.MakeGenericMethod(typeHolder);
                generic.Invoke(this, null);
            }
            catch (Exception ex) { }
        }
        protected override void OnPageIndexChanging(GridViewPageEventArgs e)
        {
            try
            {
                if (!IsIndexChange)
                {
                    PageIndex = e.NewPageIndex;
                    
                    MethodInfo method = this.GetType().GetMethod("BindGrid");
                    MethodInfo generic = method.MakeGenericMethod(typeHolder);
                    generic.Invoke(this, null);

                    base.OnPageIndexChanged(e);
                }
                else
                    IsIndexChange = false;
            }
            catch (Exception ex) { }
        }


        /// <summary>
        /// Function to add sorting icons 
        /// </summary>
        /// <param name="index"></param>
        /// <param name="row"></param>
        private void sortingIcon(int index, GridViewRow row)
        {
            System.Web.UI.WebControls.Label lblSorting = new System.Web.UI.WebControls.Label();
            if (lblSortDirection == "desc")
            {
                lblSorting.Text = "<span style=\"font-family:Marlett; font-weight:bold\">6</span>";
            }
            else
            {
                lblSorting.Text = "<span style=\"font-family:Marlett; font-weight:bold\">5</span>";
            }
            row.Cells[index].Controls.Add(lblSorting);
        }
        /// <summary>
        /// function to get sorting index of column
        /// </summary>
        /// <returns></returns>
        private int GetSortColumnIndex()
        {
            foreach (DataControlField field in this.Columns)
            {
                if (field.SortExpression.ToString() == lblSortExp)
                {
                    return this.Columns.IndexOf(field);
                }
            }
            return -1;
        }

    }
}